// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int MAXN = 1000;
int MAXV = 1000;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);

	if (validator.group() == "1") {
		MAXN = 1;
	} else if (validator.group() == "2") {
		MAXN = 10;
	} else if (validator.group() == "4") {
		MAXV = 100;
	}

	int n = inf.readInt(1, MAXN, "n");
	inf.readEoln();
	vector<int> arr;
	for (int i = 0; i < n; ++i) {
		int num = inf.readInt(1, MAXV, format("a_%d", i + 1));
		if (i < n - 1) {
			inf.readSpace();
		}
		arr.push_back(num);
		if (i) {
			ensuref(arr[i - 1] < arr[i], "sequence should be increasing");
		}
	}

	inf.readEoln();

	inf.readEof();

	if (validator.group() == "2") {
		for (int i = 0; i < n; ++i) {
			ensuref(arr[i] == (1 << i), "in group #2, a_%d = 2^{%d}", i + 1, i);
		}
	}
	if (validator.group() == "3") {
		for (int i = 0; i < n - 1; ++i) {
			ensuref(arr[i] * 2 + 1 >= arr[i + 1], "in group #3, a_%d * 2 + 1 >= a_%d", i + 1, i + 2);
		}
	}

	return 0;
}